
//
// $Id: str.h,v 1.1.1.1 2000/11/29 13:21:08 dredd Exp $
//
// $Source: /cvsroot/hammerhead/hammerhead/utils/str.h,v $
// $Revision: 1.1.1.1 $
// $Date: 2000/11/29 13:21:08 $
// $State: Exp $
//
// Author: Geoff Wong
//
/*
 * String support routines (dynamic allocation etc)
 * Author: Geoff Wong
 */

#include <sys/types.h>
#include <regex.h>
#include <string.h>
#include "String.h"

char * string_copy(const char *);
    // allocate memory and copy a string

String itoa(int);
    // convert a number to a String

String itodot(int);
	// convert a number to dot notation.

String randomstr(int width);
    // return a String full of crap

int split(String, String *, int max, String sep);

int gsub(String& str, const String& pat, const String& repl);
	// global substitution of patterns found in a string

int reggsub(String& str, const String& regpat, const String& repl);

int regfind(const String& str, const String& pat);
